local mPhotonView,mJavaBridge = ...


local mTagRecyclerView = nil
local mAppRecyclerView = nil

local _scene = nil
local _sourcescene = nil
local _modeltype = nil
local _sourceslotid = nil
local _slotid = nil
local itemCount = nil
local mController = nil

local textPaint = nil
local DEFAULT_SELECTED_TAG_TEXT = 'default'
local selectTag = DEFAULT_SELECTED_TAG_TEXT

local TAG_RV_WIDTH = 244 -- 标签所在的recyclerview的总宽度为244

local IMAGE_WIDTH_DEF = '56'
local APP_TEXT_WIDTH_DEF = '72'
local ITEM_MARGIN_DEF = '8'
local MIN_IMAGE_WIDTH = 48 --设置这个尺寸的原因是不能小于下载按钮的尺寸

function main()
    mTagRecyclerView = mPhotonView:getParser():getChildView('rv_tag')
    mAppRecyclerView = mPhotonView:getParser():getChildView('rv_app')
    mController = luajava.createProxy('com.tencent.rapidview.deobfuscated.IRapidListDataController', IRapidListDataController)

    textPaint = mPhotonView:getParser():getChildView("textHelper"):getView():getPaint()

    Rapid:setData('selectTagText',selectTag)

    mAppRecyclerView:getView():setClipToPadding(false)
    mAppRecyclerView:getView():setClipChildren(false)
end

-- 每次更新重置列表宽度
function resetTagListViewWidth()
    local title = Rapid:getData('card_title', '')
    local titleWidth = mJavaBridge:px2dip(textPaint:measureText(title))

    TAG_RV_WIDTH = 360 - 16 - 16 - 8 - titleWidth
end

function updateTagList()
    local iconWidth = Rapid:getData('icon_size','0')
    if tonumber(iconWidth) <= 0 then
        Rapid:setData('icon_size', IMAGE_WIDTH_DEF)
    else
        if tonumber(iconWidth) < MIN_IMAGE_WIDTH then
            Rapid:setData('icon_size', MIN_IMAGE_WIDTH)
        end
    end

    local outerIndex = tonumber(mPhotonView:getParser():getBinder():get("position"))
    if outerIndex == nil then
        outerIndex = tonumber(mPhotonView:getParser():getBinder():get("index"))
    end
    mTagRecyclerView:getView():attachToListController(outerIndex, mController)

    resetTagListViewWidth()

    _scene = mPhotonView:getParser():getBinder():get("scene")
    _sourcescene = mPhotonView:getParser():getBinder():get("sourcescene")
    _modeltype = mPhotonView:getParser():getBinder():get("modeltype")
    _sourceslotid =  mPhotonView:getParser():getBinder():get("sourcesceneslotid")
    _slotid =  mPhotonView:getParser():getBinder():get("slotid")
    itemCount = tonumber(Rapid:getData('item_num','0'))

    local cardRid = Rapid:getData('card_recommendid')
    local cardRContext = Rapid:getData('card_report_context')

    local dataList = {}
    local viewNameList = {}
    local subViewName = 'exp_classify_horizontal_scroll_app_card_tag_item.xml'
    local index = 0

    for i = 1, itemCount do
        local itemData = mPhotonView:getParser():getBinder():get("item_data_" .. i)

        local isTag = tostring(itemData:get("is_tag"))
        if isTag ~= nil and isTag == "1" then
            if isAddTag(itemData) then
                putBaseReportText(itemData)
                index = index + 1

                local var_selected = mJavaBridge:create("Var", '0')
                itemData:put("isSelected",var_selected)
                local var_callback = mJavaBridge:create("Var", CallbackObject)
                itemData:put("callback",var_callback)
                itemData:put("card_recommendid",mJavaBridge:create("Var", cardRid))
                itemData:put("card_report_context",mJavaBridge:create("Var", tostring(cardRContext)))

                itemData:put("selectTagText",mJavaBridge:create("Var", selectTag))
        
                dataList[index] = itemData
                viewNameList[index] = subViewName

                -- 设置曝光flag
                -- 获取appid作为前缀
                local id = tostring(itemData:get("appid"))
                mTagRecyclerView:getView():setViewShowFlag(index, id .. "view_show_flag" .. index)
            end
        end
    end

    local _position = mPhotonView:getParser():getBinder():get("position")
    mTagRecyclerView:getView():autoReport(tonumber(_position), itemCount, RapidList:getController())
    mTagRecyclerView:getView():updateData(viewNameList, dataList, true)

    -- 先放默认的app组
    local defaultId = tostring(Rapid:getData('default_tag_id','0'))
    updateAppList(defaultId)
    
    -- 当没有标签的时候标题展示整屏
    if index > 0 then
        Rapid:getChild('tv_title'):setAttr('marginright','0')
    else
        Rapid:getChild('tv_title'):setAttr('marginright','16')
    end
end

-- 判断标签是否在一屏内显示完全，显示不完全则不加入显示列表
function isAddTag(itemData)
    local curTagText = tostring(itemData:get('tag_title'))
    if curTagText ~= nil and curTagText ~= '' then
        -- 文字的宽度
        local textWidth = mJavaBridge:px2dip(textPaint:measureText(curTagText))
        -- 视图的总宽度
        local viewWidth = textWidth + 9.6 + 9.6 + 7.8 + 1.2

        if ((TAG_RV_WIDTH - viewWidth) >= 0) then
            -- 放入该标签则总宽度减去当前标签所占视图的宽度
            TAG_RV_WIDTH = TAG_RV_WIDTH - viewWidth
            return true
        end
    end
    return false
end

function updateAppList(mTagId)
    local dataList = {}
    local viewNameList = {}
    local subViewName = 'exp_classify_horizontal_scroll_app_card_app_item.xml'

    local index = 0

    local itemMargin = tonumber(Rapid:getData('horizontal_item_margin', ITEM_MARGIN_DEF))
    local iconSize = tonumber(Rapid:getData('icon_size',IMAGE_WIDTH_DEF))

    for i = 1, itemCount do
        local itemData = mPhotonView:getParser():getBinder():get("item_data_" .. i)

        local isTag = tostring(itemData:get("is_tag"))
        if isTag ~= nil and isTag == '0' then
            
            local tagId = tostring(itemData:get("tag_id"))
            if tagId ~= nil and tagId == mTagId then
                index = index + 1
                putBaseReportText(itemData)
                itemData:put("selectTagText",mJavaBridge:create("Var", selectTag))
                itemData:put("subPosition",mJavaBridge:create("Var", index))
                itemData:put("app_slotId",mJavaBridge:create("Var", tostring(Rapid:getData("slotId")) .. "_-1_"..index))
                itemData:put("icon_size",mJavaBridge:create("Var", iconSize))
                itemData:put("horizontal_item_margin",mJavaBridge:create("Var", itemMargin))

                if useIconWidth(iconSize) == false then
                    itemData:put("app_text_size",mJavaBridge:create("Var", APP_TEXT_WIDTH_DEF))
                else
                    itemData:put("app_text_size",mJavaBridge:create("Var", iconSize))
                end

                if (itemData ~= nil) then
                    dataList[index] = itemData
                    viewNameList[index] = subViewName
                end
            end
        end
    end

    local defLeft = 8
    local defRight = 16
    if useIconWidth(iconSize) == false then
        local margin = (tonumber(APP_TEXT_WIDTH_DEF) - tonumber(iconSize)) / 2
        defLeft = defLeft - margin
        defRight = defRight - margin
    end

    for i = 1, index do
        local itemData = dataList[i]
        if i == 1 then
            itemData:put("marginleft",mJavaBridge:create("Var", defLeft))
        elseif i == index then
            itemData:put("horizontal_item_margin",mJavaBridge:create("Var", defRight))
        end
        dataList[i] = itemData
    end

    mAppRecyclerView:getView():removeAllViews()
    mAppRecyclerView:getView():updateData(viewNameList, dataList, true)
    if index > 0 then
        mAppRecyclerView:getView():scrollToPosition(0)
    end
end

function useIconWidth(iconSize)
    return tonumber(iconSize) < tonumber(IMAGE_WIDTH_DEF) or tonumber(iconSize) >= tonumber(APP_TEXT_WIDTH_DEF)
end

CallbackObject = {}
CallbackObject.onClickTag = function(mTagId, isSelected)

    local findSelectTagText = nil
    for i = 1, itemCount do
        local itemData = mPhotonView:getParser():getBinder():get("item_data_" .. i)

        local isTag = tostring(itemData:get("is_tag"))
        local tagId = tostring(itemData:get("tag_id"))
        if isTag ~= nil and isTag == "1" and mTagId == tagId then
            -- 找到了点击的标签，更新该标签的状态
            local tagText = tostring(itemData:get("tag_title"))
            if isSelected then
                itemData:put("isSelected",mJavaBridge:create("Var", '1'))
                findSelectTagText = tagText
            else
                itemData:put("isSelected",mJavaBridge:create("Var", '0'))
            end
        else
            -- 未被点击的标签都置为未点击状态
            itemData:put("isSelected",mJavaBridge:create("Var", '0'))
        end
    end

    if findSelectTagText ~= nil and findSelectTagText ~= '' then
        selectTag = findSelectTagText
    else
        selectTag = DEFAULT_SELECTED_TAG_TEXT
    end

    -- 更新标签列表
    mTagRecyclerView:getView():notifyDataSetChanged()

    -- 更新标签下的应用列表，如果选中了某个标签，则加载该标签下的应用，否则加载默认应用
    if isSelected then
        updateAppList(mTagId)
    else
        local defaultId = tostring(Rapid:getData('default_tag_id','0'))
        updateAppList(defaultId)
    end
end

IRapidListDataController = {}
function IRapidListDataController.updateItemData(index, key, val)
    Rapid:setData(key, val)
    RapidList:updateItemData(index, key, val)
end

function IRapidListDataController.reload()
end

function IRapidListDataController.getItemData(index, key)
    return RapidList:getItemData(index, key)
end

function putBaseReportText(itemData)
    if itemData == nil then
        return
    end

    if _scene ~= nil then
        local var_scene = mJavaBridge:create("Var", _scene)
        itemData:put("scene",var_scene)
    end
    
    if _sourcescene ~= nil then
        local var_sourcescene = mJavaBridge:create("Var", _sourcescene)
        itemData:put("sourcescene",var_sourcescene)
        itemData:put("sourceScene",var_sourcescene)
    end
    
    if _modeltype ~= nil then
        local var_modeltype = mJavaBridge:create("Var", _modeltype)
        itemData:put("modeltype",var_modeltype)
        itemData:put("modelType",var_modeltype)
    end
    
    if _sourceslotid ~= nil then
        local var_sourceslotid = mJavaBridge:create("Var", _sourceslotid)
        itemData:put("sourcesceneslotid",var_sourceslotid)
        itemData:put("sourceSceneSlotId",var_sourceslotid)
    end
    
    if _slotid ~= nil then
        local var_slotid = mJavaBridge:create("Var", _slotid)
        itemData:put("slotid",var_slotid)
        itemData:put("slotId",var_slotid)
    end
end