local mPhotonView,mJavaBridge = ...

local mIsShowedNewFeatureAll = false

function main()
    mJavaBridge:Log("UpdateListLoader", "item lua start") 
end

function refresh()
    local is_diff_update = mPhotonView:getParser():getBinder():get("is_diff_update")
    if is_diff_update ~= nil then
        if is_diff_update == "0" then
            Rapid:getChild("diff_size"):setAttr("visibility", "gone")
            Rapid:getChild("origin_size"):getView():getPaint():setStrikeThruText(false)
        else
            Rapid:getChild("diff_size"):setAttr("visibility", "VISIBLE")
            Rapid:getChild("origin_size"):getView():getPaint():setStrikeThruText(true)
        end
    end

    refreshNewFeatureAllLayout()
end

function refreshNewFeatureAllLayout()
    local isShowedNewFeatureAll = mPhotonView:getParser():getBinder():get("isShowedNewFeatureAll")
    if (isShowedNewFeatureAll ~= nil) then
        if (isShowedNewFeatureAll == "true") then
            showNewFeatureAll()
        elseif (isShowedNewFeatureAll == "false") then
            hideNewFeatureAll()
        end
    end
end

function clickShowNewFeatureAll()
    local isShowedNewFeatureAll = mPhotonView:getParser():getBinder():get("isShowedNewFeatureAll")
    mJavaBridge:Log("UpdateListLoader", "isShowedNewFeatureAll = ")
    mJavaBridge:Log("UpdateListLoader", isShowedNewFeatureAll)
    if (isShowedNewFeatureAll ~= nil) then
        if (isShowedNewFeatureAll == "true") then
            updateShowAllNewFeatureState("false")
            hideNewFeatureAll()
        elseif (isShowedNewFeatureAll == "false") then
            updateShowAllNewFeatureState("true")
            showNewFeatureAll()
        end
    else
        updateShowAllNewFeatureState("false")
        hideNewFeatureAll()
    end
end

function updateShowAllNewFeatureState(state)
    mPhotonView:getParser():getBinder():update("isShowedNewFeatureAll", state)
    local params = {}
    if state == "true" then
        params["key"] = "showNewFeature"
    else
        params["key"] = "hideNewFeature"
    end
    params["value"] = mPhotonView:getParser():getBinder():get("index")
    local listener = Rapid:getData("listener")
    if listener ~= nil then
        listener.notify(params["key"], params["value"])
    end
end

function showNewFeatureAll()
    -- 展开全部新版特性
    Rapid:getChild("new_feature"):setAttr("visibility", "gone")
    Rapid:getChild("new_feature_all"):setAttr("visibility", "VISIBLE")
    Rapid:getChild("ignore_update"):setAttr("visibility", "VISIBLE")
    Rapid:getChild("showMoreDesc"):setAttr("image", "arrow_up.png")

    mJavaBridge:Log("UpdateListLoader", "mIsShowedNewFeatureAll: true")
end

function hideNewFeatureAll()
    -- 收起全部新版特性
    Rapid:getChild("new_feature"):setAttr("visibility", "VISIBLE")
    Rapid:getChild("new_feature_all"):setAttr("visibility", "gone")
    Rapid:getChild("ignore_update"):setAttr("visibility", "gone")
    Rapid:getChild("showMoreDesc"):setAttr("image", "arrow_down.png")

    mJavaBridge:Log("UpdateListLoader", "mIsShowedNewFeatureAll: false") 
end

-- 设置卡片圆角
function setCardCorner(type)
    local Color = luajava.bindClass("android.graphics.Color")
    local bgDrawable = luajava.newInstance("android.graphics.drawable.GradientDrawable")
    local cornerSize = mJavaBridge:dip2px(14)
    if (type == "top_corner") then
        bgDrawable:setCornerRadii({cornerSize, cornerSize, cornerSize, cornerSize, 0, 0, 0, 0})  -- 设置图片四个角圆形半径：1、2两个参数表示左上角，3、4表示右上角，5、6表示右下角，7、8表示左下角
    elseif (type == "bottom_corner") then
        bgDrawable:setCornerRadii({0, 0, 0, 0, cornerSize, cornerSize, cornerSize, cornerSize})
    end
    bgDrawable:setColor(Color:parseColor("#ffffff"))
    bgDrawable:setGradientCenter(0, 0)
    bgDrawable:setGradientType(0)
    local item_layout = mPhotonView:getParser():getChildView('item_layout'):getView()
    item_layout:setBackgroundDrawable(bgDrawable)
end

function changeState()
    mJavaBridge:Log("UpdateListLoader", "lua start changeState") 
    local params = {}
    params["key"] = "changeState"
    params["value"] = mPhotonView:getParser():getBinder():get("listindex")
    local listener = Rapid:getData("listener")

    if listener ~= nil then
        listener.notify(params["key"], params["value"])
    end
end

function clickIgnoreUpdate()
    local appSimpleDetail = mPhotonView:getParser():getBinder():get("app_simple_detail")
    mJavaBridge:ignoreUpdate(mJavaBridge:create("var", appSimpleDetail))

    local params = {}
    params["key"] = "ignoreUpdate"
    params["value"] = mPhotonView:getParser():getBinder():get("app_id")..","..mPhotonView:getParser():getBinder():get("listindex")
    local listener = Rapid:getData("listener")
    if listener ~= nil then
        listener.notify(params["key"], params["value"])
    end
end